unit unPickDate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, Calendar, ComCtrls, Spin;

type
  TfoPickDate = class(TForm)
    btOK: TBitBtn;
    BitBtn2: TBitBtn;
    EDay: TSpinEdit;
    DatePick: TDateTimePicker;
    EMonth: TComboBox;
    EYear: TSpinEdit;
    Calendar: TCalendar;
    Label14: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    BitBtn1: TBitBtn;
    procedure CalendarChange(Sender: TObject);
    procedure CalendarDblClick(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure EDayChange(Sender: TObject);
    procedure EMonthChange(Sender: TObject);
    procedure EYearChange(Sender: TObject);
    procedure DatePickChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
    Date : TDateTime;
  end;

var
  foPickDate: TfoPickDate;


implementation

{$R *.DFM}


procedure TfoPickDate.CalendarChange(Sender: TObject);
begin
 EMonth.Text:=EMonth.Items[Calendar.Month-1];
 EDay.Value:=Calendar.Day;
 EYear.Value:=Calendar.Year;
 With Calendar do
   datePick.Date:=EncodeDate(Year,Month,Day);
end;

procedure TfoPickDate.CalendarDblClick(Sender: TObject);
Begin
 btOK.Click;
end;

procedure TfoPickDate.btOKClick(Sender: TObject);
Var
 m,y,d : Word;
begin
 With Calendar do
  Begin
   m:=Month;
   d:=Day;
   Y:=Year;
  End;
 foPickDate.Date:=EnCodeDate(y,m,d);
 foPickDate.Tag:=mrOk;

 Close;
end;

procedure TfoPickDate.EDayChange(Sender: TObject);
begin
 Calendar.Day:=EDay.Value;
end;

procedure TfoPickDate.EMonthChange(Sender: TObject);
begin
 Calendar.Month:=EMonth.ItemIndex+1;
end;

procedure TfoPickDate.EYearChange(Sender: TObject);
begin
  Calendar.Year:=EYear.Value;
end;


procedure TfoPickDate.DatePickChange(Sender: TObject);
Var
 y,m,d : Word;
begin
 DecodeDate(DatePick.Date,y,m,d);
 With Calendar do
  Begin
   Day:=D;
   Month:=M;
   Year:=Y;
  End;
 EDay.Value:=d;
 EMonth.Text:=EMonth.Items[m-1];
 EYear.Value:=y;
end;

procedure TfoPickDate.BitBtn1Click(Sender: TObject);
Var
 y,m,d : Word;
begin
 DatePick.Date:=Now;

 DecodeDate(DatePick.Date,y,m,d);
 With Calendar do
  Begin
   Day:=D;
   Month:=M;
   Year:=Y;
  End;
 EDay.Value:=d;
 EMonth.Text:=EMonth.Items[m-1];
 EYear.Value:=y;

end;

procedure TfoPickDate.BitBtn2Click(Sender: TObject);
begin
 foPickDate.Tag:=mrCancel;
 Close;
end;

procedure TfoPickDate.FormShow(Sender: TObject);
Var
 y,m,d : Word;
begin
 DatePick.Date:=foPickDate.Date;

 DecodeDate(DatePick.Date,y,m,d);
 With Calendar do
  Begin
   Day:=D;
   Month:=M;
   Year:=Y;
  End;
 EDay.Value:=d;
 EMonth.Text:=EMonth.Items[m-1];
 EYear.Value:=y;

 Calendar.SetFocus;
end;



end.
